Codeforces 1324 D-Pair of Topics(思维+二分 || 双指针)

Pair of Topics

time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
The next lecture in a high school requires two topics to be discussed. The i-th topic is interesting by ai units for the teacher and by bi units for the students.

The pair of topics i and j (i<j) is called good if ai+aj>bi+bj (i.e. it is more interesting for the teacher).

Your task is to find the number of good pairs of topics.

Input
The first line of the input contains one integer n (2≤n≤2⋅105) — the number of topics.

The second line of the input contains n integers a1,a2,…,an (1≤ai≤109), where ai is the interestingness of the i-th topic for the teacher.

The third line of the input contains n integers b1,b2,…,bn (1≤bi≤109), where bi is the interestingness of the i-th topic for the students.

Output
Print one integer — the number of good pairs of topic.

Examples
inputCopy

5
4 8 2 6 2
4 5 4 1 3
outputCopy
7
inputCopy
4
1 3 2 4
1 3 2 4
outputCopy
0
题意:
给你两个数组a[i]和b[i],问有多少对 ( i , j ) 满足i<j 并a[i]+a[j]>b[i]+b[j]。
思路一:二分
可以对式子进行化简,变为a[i]+a[j]-b[i]-b[j]>0,相当于a[i]-b[i]+(b[j]-a[j]) >0 。
可以再开一个新的数组c[i]=a[i]-b[i],那么问题就转变成了:在数组c中寻找一组数,使得其满足i<j 并且 c[i] +c[j]>0
这时候有两种解法:
一是直接两层for循环枚举,复杂度是n^2,显然对于本题,2e5*2e5并不可取。

二是优化第二层for循环,我们可以对c数组升序排序,上述式子可以化成c[j] >-c[i] , 那么我们可以在第二层for循环的时候直接二分查找第一个大于 -c[i] 的数的位置tmp,那么这个位置及其之后的位置一定符合题意,即 sum+=n-tmp+1;
但是这里要注意c[i] >0 的情况,因为查找的是-c[i] ,所以c[i]也符合查找条件,但是并不符合题意,我们要出去这种情况。
最后需要注意我们每一个逆序对都计算了两遍,需要把结果/2再输出。这样的复杂度就是n*lgn。
最后的最后,要注意在这种思路下,会爆int,所以要用long long 计数。
二分代码:

#include<bits/stdc++.h>
using namespace std;
const int maxn=1e6+7;
typedef long long ll;
ll n,a[maxn],sum;
int main(){
    cin>>n;
    int x;
    for(int i=1;i<=n;i++) cin>>a[i];
    for(int i=1;i<=n;i++){
        cin>>x;
        a[i]-=x;
    }
    sort(a+1,a+1+n);
    for(int i=1;i<=n;i++) cout<<a[i]<<" ";
    puts("");
    for(int i=1;i<=n;i++){
        int tmp=upper_bound(a+1,a+1+n,-a[i])-a;
        sum+=n-tmp+1;
		if (a[i]>0) sum--;
		 //cout<<i<<" "<<tmp<<" "<<sum<<endl;//检测输出
    }
    cout<<sum/2;
    return 0;
}

思路二:双指针
一般来说,能二分的都能用双指针解决,复杂度基本相同~
双指针代码:

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn=1e6+7;
int n,a[maxn],x,l,r;
ll ans;
int main()
{
	scanf("%d",&n);
	r=n;
	for(int i=1;i<=n;i++) cin>>a[i];
	for(int i=1;i<=n;i++) cin>>x,a[i]-=x;
	sort(a+1,a+n+1);
	for(int l=1;l<=n;l++)
	{
		while(a[l]+a[r]>0)r--;///找最后一个满足条件的位置
		ans+=n-max(l,r);//该位置之后的一定满足条件
	}
	printf("%lld",ans);
	return 0;
}

以前在牛客做过一个类似的题,暂时还没找到,先这样叭,这个题再推一下就能解决了qwq 写题解的时候才发现自己推错了。。
还有一种通用的解法,当不具备单调性时可以用树状数组或线段树维护,待补。

  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 1
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

豆沙睡不醒

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值